core:
  regular_file: [$fi]
  directory: [$di]

  executable_file: [$ex]

  symlink: [$ln]
  broken_symlink: [$or, $mi]

  fifo: [$pi]
  socket: [$so]

  normal_text: [$no]

  block_device: [$bd]
  character_device: [$cd]

text:
  special:
    - CONTRIBUTORS
    - CONTRIBUTORS.md
    - CONTRIBUTORS.txt
    - INSTALL
    - INSTALL.md
    - INSTALL.md.txt
    - README
    - README.md
    - README.txt
    - README.org

  todo:
    - TODO
    - TODO.md
    - TODO.txt

  licenses:
    - COPYING
    - COPYRIGHT
    - LICENSE
    - LICENSE-APACHE
    - LICENSE-MIT

  configuration:
    generic:
      - .cfg
      - .conf
      - .config
      - .ini
      - .json
      - .tml
      - .toml
      - .yaml
      - .yml

    metadata:
      - .xmp

    bibtex:
      - .bib
      - .bst

    dockerfile:
      - Dockerfile

    nix:
      - .nix

    qt:
      - .ui

    desktop:
      - .desktop

    system:
      - passwd
      - shadow

  other:
    - .txt

markup:
  web:
    - .htm
    - .html
    - .shtml
    - .xhtml

  other:
    - .csv
    - .markdown
    - .md
    - .mdown
    - .rst
    - .xml
    - .org

  latex: [.tex, .ltx]

programming:
  source:
    actionscript: [.as]
    applescript: [.applescript]
    asp: [.asa]
    awk: [.awk]
    basic: [.vb]
    cabal: [.cabal]
    clojure: [.clj]
    crystal: [.cr]
    csharp: [.cs, .csx]
    css: [css]
    cxx: [.c, .cpp, .cc, .cp, .cxx, .c++, .h, .hh, .hpp, .hxx, .h++, .inl, .ipp]
    d: [.d, .di]
    dart: [.dart]
    diff: [.diff, .patch]
    elixir: [.ex, .exs]
    elm: [.elm]
    erlang: [.erl]
    fsharp: [.fs, .fsi, .fsx]
    go: [.go]
    graphviz: [.dot, .gv]
    groovy: [.groovy, .gvy, .gradle]
    haskell: [.hs]
    ipython: [.ipynb]
    java: [.java, .bsh]
    javascript: [.js, .htc]
    julia: [.jl]
    kotlin: [.kt, .kts]
    less: [.less]
    lisp: [.lisp, .el, .scm]
    lua: [.lua]
    mathematica: [.nb]
    matlab: [.matlab, .m, .mn]
    ocaml: [.ml, .mli]
    pascal: [.pas, .p, .dpr]
    perl: [.pl, .pm, .pod, .t, .cgi]
    php: [.php]
    powershell: [.ps1, .psm1, .psd1]
    puppet: [.pp, .epp]
    purescript: [.purs]
    python: [.py]
    r: [.r]
    ruby: [.rb]
    rust: [.rs]
    scala: [.scala, .sbt]
    shell: [.sh, .bash, .zsh, .fish]
    sql: [.sql]
    swift: [.swift]
    tcl: [.tcl]
    typescript: [.ts, .tsx]
    vhdl: [.xdc, .xci, .vho, .vhd , .veo , .vh , .v]
    viml: [.vim]

  tooling:
    vcs:
      git:
        - .gitignore
        - .gitmodules
        - .gitattributes
        - .gitconfig

      hg:
        - .hgrc
        - hgrc

      other:
        - CODEOWNERS
        - .ignore
        - .fdignore
        - .rgignore

    build:
      cmake:
        - .cmake
        - CMakeLists.txt
        - .cmake.in

      make:
        - Makefile
        - .make

      automake:
        - Makefile.am

      configure:
        - configure
        - configure.ac

      scons:
        - SConscript
        - SConstruct

      pip:
        - requirements.txt

    packaging:
      python:
        - MANIFEST.in
        - setup.py
      ruby:
        - .gemspec

    code-style:
      python:
        - .flake8

      cxx:
        - .clang-format

    editors:
      qt:
        - .pro
      kdevelop:
        - .kdevelop

    documentation:
      doxygen:
        - Doxyfile
        - .dox

    continuous-integration:
      - appveyor.yml
      - .travis.yml

media:
  image:
    - .bmp
    - .gif
    - .ico
    - .jpeg
    - .jpg
    - .JPG
    - .pbm
    - .pgm
    - .png
    - .ppm
    - .svg
    - .tif
    - .xcf

  audio:
    - .aif
    - .flac
    - .mid
    - .mp3
    - .ogg
    - .wav
    - .wma

  video:
    - .avi
    - .flv
    - .h264
    - .m4v
    - .mkv
    - .mov
    - .mp4
    - .mpeg
    - .mpg
    - .rm
    - .swf
    - .vob
    - .wmv

  fonts:
    - .fnt
    - .fon
    - .otf
    - .ttf

office:
  document:
    - .doc
    - .docx
    - .epub
    - .odt
    - .pdf
    - .djvu
    - .ps
    - .rtf
    - .sxw

  spreadsheet:
    - .xls
    - .xlsx
    - .ods
    - .xlr

  presentation:
    - .ppt
    - .pptx
    - .odp
    - .sxi
    - .kex
    - .pps

  calendar:
    - .ics

archives:
  packages:
    - .apk
    - .deb
    - .rpm

  ros:
    - .bag

  images:
    - .bin
    - .dmg
    - .img
    - .iso
    - .toast
    - .vcd

  other:
    - .7z
    - .arj
    - .bz
    - .bz2
    - .gz
    - .jar
    - .pkg
    - .rar
    - .tar
    - .tbz
    - .tbz2
    - .tgz
    - .xz
    - .z
    - .zip

executable:
  windows:
    - .bat
    - .com
    - .exe

  library:
    - .so
    - .a
    - .dll

  linux:
    - .ko

unimportant:
  build_artifacts:
    cxx:
      - .o
      - .la
      - .lo
    cmake:
      - CMakeCache.txt
    automake:
      - Makefile.in
    rust:
      - .rlib
    python:
      - .pyc
    haskell:
      - .dyn_hi
      - .dyn_o
      - .cache
      - .hi
    java:
      - .class
    scons:
      - .scons_opt
      - .sconsign.dblite
    latex:
      - .aux
      - .bbl
      - .nlo
      - .lof
      - .bcf
      - .blg
      - .fdb_latexmk
      - .fls
      - .idx
      - .ilg
      - .ind
      - .out
      - .sty
      - .synctex.gz
      - .toc
      - .lol
      - .lot
      - .pygtex
      - .pygstyle
    tags:
      - GPATH
      - GRTAGS
      - GTAGS

  other:
    - "~"
    - .bak
    - .git  # only works for '.git' files (submodules)
    - .lock
    - .log
    - .log.1
    - .log.2
    - .log.3
    - .log.4
    - .orig
    - .pid
    - .swp
    - .tmp
    - package-lock.json
